//
//  AppDelegate.m
//  MultiWindowDemo
//
//  Created by Nate Chandler on 10/30/12.
//  Copyright (c) 2012 Nate Chandler. All rights reserved.
//

#import "AppDelegate.h"
#import "LoginWindowController.h"
#import "TimelineWindowController.h"

@interface AppDelegate ()
@property (nonatomic) LoginWindowController *loginWindowController;
@property (nonatomic) TimelineWindowController *timelineWindowController;

@property (nonatomic) BOOL isLoggedIn;
@end


@implementation AppDelegate

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
	self.isLoggedIn = NO;
	[self updateWindowVisibility];
}

- (void)updateWindowVisibility
{
	BOOL loginWindowShouldBeVisible = !self.isLoggedIn;
	BOOL loginWindowIsVisibile = self.loginWindowController.window.isVisible;

	BOOL timelineWindowShouldBeVisible = self.isLoggedIn;
	BOOL timelineWindowIsVisible = self.timelineWindowController.window.isVisible;
	
	if (loginWindowShouldBeVisible && !loginWindowIsVisibile) {
		if (!self.loginWindowController) self.loginWindowController = [[LoginWindowController alloc] init];
		[self.loginWindowController showWindow:nil];
	} else if (!loginWindowShouldBeVisible && loginWindowIsVisibile) {
		[self.loginWindowController close];
		self.loginWindowController = nil;
	}
	
	if (timelineWindowShouldBeVisible && !timelineWindowIsVisible) {
		if (!self.timelineWindowController) self.timelineWindowController = [[TimelineWindowController alloc] init];
		[self.timelineWindowController showWindow:nil];
	} else if (!timelineWindowShouldBeVisible && timelineWindowIsVisible) {
		[self.timelineWindowController close];
		self.timelineWindowController = nil;
	}
}

- (IBAction)toggleLoggedIn:(id)sender
{
	self.isLoggedIn = !self.isLoggedIn;
	[self updateWindowVisibility];
}

+ (NSSet *)keyPathsForValuesAffectingToggleLoggedInMenuItemTitle
{
	return [NSSet setWithObject:@"isLoggedIn"];
}

- (NSString *)toggleLoggedInMenuItemTitle
{
	return (self.isLoggedIn) ? @"Log Out" : @"Log In";
}

@end
